<?php

$fliprID=getArg('fliprid', $mandatory = true, $default = '');
$ForcedReload=getArg('forcedreload', $mandatory = false, $default = false);
$ApiUrl = 'https://api.goflipr.com/v1.1/modules/'.$fliprID.'/report/last';

if ($ForcedReload)
{
  $CACHE_DURATION = 0; // minutes
}
else
{
  $CACHE_DURATION = 30; // minutes
}




$last_xml_success = loadVariable('last_xml_success');
if ((time() - $last_xml_success) / 60 < $CACHE_DURATION)
{
	sdk_header('text/xml');
	$cached_xml = loadVariable('cached_xml');
  $cached_xml = str_replace('<Cachestatus>0</Cachestatus>', '<Cachestatus>1</Cachestatus>', $cached_xml);
	echo $cached_xml;
	die();
}
else
{ 
 $response = httpQuery($ApiUrl);
 $arrResponse = sdk_json_decode($response);
 //var_dump($arrResponse);
 //$XmlResult=jsonToXML($response);
 //echo $XmlResult;
 sdk_header('text/xml');
 $XmlResult.="<?xml version='1.0' encoding='ISO-8859-1'?><root><cached>";
 $XmlResult.='<Cachestatus>0</Cachestatus>';
 $XmlResult.='<CacheTime>'.date(DATE_RFC2822).'</CacheTime>';
 $XmlResult.='</cached>';
 $XmlResult.='<BatteryLevel>'.round(($arrResponse['BatteryLevel']/3596)*100,0).'</BatteryLevel>';
 $XmlResult.='<Conductivity>'.round($arrResponse['Conductivity'],0).'</Conductivity>';
 $XmlResult.='<PH>'.round($arrResponse['PH'],1).'</PH>';
 $XmlResult.='<IsOutOfWater>'.$arrResponse['IsOutOfWater'].'</IsOutOfWater>';
 $XmlResult.='<Temperature>'.round($arrResponse['Temperature'],1).'</Temperature>';
 $XmlResult.='<Salinity>'.round($arrResponse['Salinity'],1).'</Salinity>';
 $XmlResult.='<FreeChlore>'.round($arrResponse['FreeChlore'],2).'</FreeChlore>';
 $XmlResult.='<FreeChloreOrpPh>'.round($arrResponse['FreeChloreOrpPh'],2).'</FreeChloreOrpPh>';
 $XmlResult.='<FreeChloreOrpCya>'.round($arrResponse['FreeChloreOrpCya'],2).'</FreeChloreOrpCya>';
 $XmlResult.='<Brome>'.round($arrResponse['Brome'],2).'</Brome>';
 $XmlResult.='<CyanuricAcid>'.$arrResponse['CyanuricAcid'].'</CyanuricAcid></root>';
 
 #set last_xml_success
 saveVariable('last_xml_success', time());
  
 #set cached_xml
 saveVariable('cached_xml', $XmlResult);
 
 // XML de sortie
 echo $XmlResult;
 
}

?>